/* -*- mode: c -*- */

%module ncurses
%{

/* see __scm.h for SCM_FENCE and info gcc for ansification and 'asm' */
#define asm __asm__

#include "../config.h"

#include <ncurses/curses.h>

%}

%include "ports.i"

%include "typemaps_ext.i"

typedef unsigned long chtype;
typedef unsigned long attr_t;

/* all multiple values return functions use (values ...) */
/* bug?.. */
/* %multiple_values */
%pragma(guile) beforereturn = "GUILE_MAYBE_VALUES"

/* to pass NULL to newterm() */
%typemap(guile,in) char *MAYBE_NULL
{
  if(SCM_NULLP($source))
  {
	$target = NULL;
  }
  else
  {
	$target = gh_scm2newstr($source, NULL);
  };
}
%typemap(guile,freearg) char *MAYBE_NULL 
{
  if($target) scm_must_free($target);
}

/* default ports.i behavior is to fclose() port passed to function */
%typemap(guile,freearg) FILE* "";

%include "ncurses_impl.h"
%include "ncurses_const.h"

%name(COLORS) extern int COLORS_ref(void);
%name("COLOR-PAIRS") extern int COLOR_PAIRS_ref(void);
%name("COLOR-PAIR") extern unsigned long COLOR_PAIR_ref(unsigned long n);
%name("PAIR-NUMBER") extern unsigned long PAIR_NUMBER_ref(unsigned long a);
%name(stdscr) extern WINDOW* stdscr_ref(void);
%name(curscr) extern WINDOW* curscr_ref(void);
%name(newscr) extern WINDOW* newscr_ref(void);
%name(LINES) extern int LINES_ref(void);
%name(COLS) extern int COLS_ref(void);
%name(TABSIZE) extern int TABSIZE_ref(void);
%name(ESCDELAY) extern int ESCDELAY_ref(void);
%name("acs-map") extern chtype acs_map_ref(char a);
%name("KEY_Fn") extern int key_fn(int n);
%name("ACS_ULCORNER") extern chtype acs_ULCORNER(void);
%name("ACS_LLCORNER") extern chtype acs_LLCORNER(void);
%name("ACS_URCORNER") extern chtype acs_URCORNER(void);
%name("ACS_LRCORNER") extern chtype acs_LRCORNER(void);
%name("ACS_LTEE") extern chtype acs_LTEE(void);
%name("ACS_RTEE") extern chtype acs_RTEE(void);
%name("ACS_BTEE") extern chtype acs_BTEE(void);
%name("ACS_TTEE") extern chtype acs_TTEE(void);
%name("ACS_HLINE") extern chtype acs_HLINE(void);
%name("ACS_VLINE") extern chtype acs_VLINE(void);
%name("ACS_PLUS") extern chtype acs_PLUS(void);
%name("ACS_S1") extern chtype acs_S1(void);
%name("ACS_S9") extern chtype acs_S9(void);
%name("ACS_DIAMOND") extern chtype acs_DIAMOND(void);
%name("ACS_CKBOARD") extern chtype acs_CKBOARD(void);
%name("ACS_DEGREE") extern chtype acs_DEGREE(void);
%name("ACS_PLMINUS") extern chtype acs_PLMINUS(void);
%name("ACS_BULLET") extern chtype acs_BULLET(void);
%name("ACS_LARROW") extern chtype acs_LARROW(void);
%name("ACS_RARROW") extern chtype acs_RARROW(void);
%name("ACS_DARROW") extern chtype acs_DARROW(void);
%name("ACS_UARROW") extern chtype acs_UARROW(void);
%name("ACS_BOARD") extern chtype acs_BOARD(void);
%name("ACS_LANTERN") extern chtype acs_LANTERN(void);
%name("ACS_BLOCK") extern chtype acs_BLOCK(void);
%name("ACS_S3") extern chtype acs_S3(void);
%name("ACS_S7") extern chtype acs_S7(void);
%name("ACS_LEQUAL") extern chtype acs_LEQUAL(void);
%name("ACS_GEQUAL") extern chtype acs_GEQUAL(void);
%name("ACS_PI") extern chtype acs_PI(void);
%name("ACS_NEQUAL") extern chtype acs_NEQUAL(void);
%name("ACS_STERLING") extern chtype acs_STERLING(void);

%scheme "ncurses_tmpl.scm"
%scheme "ncurses_const.scm"
%scheme "ncurses_gen.scm"
%scheme "ncurses_gen_ad.scm"
%scheme "ncurses_alias.scm"
